<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Application;
use App\Models\User;
use App\Models\InterviewSlot;
use App\Models\InterviewSheet;
use App\Models\TrainingBatch;
use App\Models\Volunteer;
use App\Models\TrainingBatchTraineesUpdate;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Validator;

use Carbon\Carbon;
use Auth;
class ApplicationController extends Controller
{

    
    public function applications($status){
        if($status == "pending"){
            $applications = Application::whereStatus('P')->get();
            
        }else if($status == 'rejected'){
            $applications = Application::whereStatus('R')->orWhere('status' , 'C')->get();
            
            return view('admin.applications.rc' , compact('applications' , 'status'));
        }else if($status == 'short-listed'){
            $applications = Application::whereStatus('S')->get();
        }else{
            $applications = Application::whereStatus('P')->get();
            
        }
        return view('admin.applications.index' , compact('applications' , 'status'));
    }
    public function application_queue(){
        
        $applications = Application::whereStatus('P')->get();
        return view('admin.applications.queue' , compact('applications'));
    }
    public function app_show($id){
        $item = Application::find($id);
        return view('admin.applications.show' , compact('item'));
    }
    public function reject_show($id){
        $item = Application::find($id);
        return view('admin.applications.rr' , compact('item'));
    }

    public function app_status(Request $request , $id , $status){

       $application = Application::find($id);
       $application->status = $status;
       $application->updated_by = Auth::user()->id;
       $user = User::find($application->user_id);
       if($status == "S"){
        $application->internal_reason = "";
        $application->extarnal_reason = "";
        $application->is_shortlist = 1;
        $application->shortlist_date = Carbon::now();
        $cname = $user->first_name;
        $to = $user->email;
        $subject="Apllication Shortlisted";
        $text="Select available Interview Slot";
        $dec="Congratulations Your application has been Shortlisted";
        $link = route('volunteer.interview-slots.index' , 'all');
        }else if($status == "R" || $status == "C"){
           
        $application->internal_reason = $request->internal_reason;
        $application->extarnal_reason = $request->extarnal_reason;
        
        // email
        $cname = $user->first_name;
        $to = $user->email;
      
        if($status=="R"){
            $subject = "Apllication Rejected";
            $text="Check Rejected Application";
            $dec="Your application has been Rejected becuase of ".$request->extarnal_reason;
        }
        if($status=="C"){
            $subject = "Apllication Close";
            $text="Check Close Application";
            $dec="Your application has been Closed becuase of ".$request->extarnal_reason;
            
        }
        $link = route('login');
        
       }
        Mail::send('email.application', ['cname' => $cname, 'dec'=>$dec ,'text' => $text, 'link' => $link], function ($message) use ($cname , $to , $subject) {
            $message->to($to , $cname);
            $message->subject($subject);
            $message->from(env('MAIL_FROM_ADDRESS') , 'Tip User');
       });
       $application->update();

       return redirect()->back()->with('success' , "Updated Successfully");
    }

    public function app_accept($id){
        // dd(InterviewSlot::get());
        $inter=InterviewSlot::Where('interviewee_id', $id)->orWhere('status', 'A')->first();
        $mytime = Carbon::now();
        $c_date= $mytime->toDateString();
        $batch =  TrainingBatch::where('batch_status','A')->where('batch_date' ,'>=',$c_date)->whereisMandatory('mandatory')->get();
        return view('admin.applications.accept' , compact('inter' , 'batch'));
    }
    public function app_hold($id){
        $inter=InterviewSlot::Where('interviewee_id', $id)->orWhere('status', 'A')->latest()->first();
        return view('admin.applications.hold' , compact('inter'));
    }

     public function form_fill($id, $status){
       
        $user = User::findorfail($id);
        // dd($user->email);
        $to = $user->email;
        $subject = "Feedback Forms";
        if($status=='one'){
            $text="Fill Form One";
        }
        if($status=='two'){
            $text="Fill Form Two";
        }
        if($status=='three'){
            $text="Fill Form Three";
        }

        $cname = $user->first_name;
        $link = route('volunteer.form.one');
        Mail::send('email.info', ['cname' => $cname, 'text' => $text, 'link' => $link], function ($message) use ($cname , $to , $subject) {
            $message->to($to , $cname);
            $message->subject($subject);
            $message->from(env('MAIL_FROM_ADDRESS') , 'Tip User');

     });
     return redirect()->back()->with('success' , "Send Successfully");
    }
      


       public function interviewee_accept(Request $request){

        $rules =
        [
          'Interview_slot_id' =>"required",
          'interview_date' =>'required|before_or_equal:today',
          'volunteer_language' => 'required',
        'education' => 'required',
        'why_interested_volunteering' => 'required',
        'prior_volunteering_experience' => 'required',
        'experience_explain_geriatic_pop_mental_helth' => 'required',
        'impact_hope_involvement' => 'required',
        'describe_communication_style_close_you' => 'required',
        'comfortable_languages' => 'required',
        'senario_speak_client_with_compalaints' => 'required',
        'have_question' => 'required',
        'additional_skills' => 'required',
        'update_notes' => 'required',
        'training_batch' => 'required|numeric',

          
        ];
        $message = [
            'Interview_slot_id.required' =>'Interview Slot is required',
            'interview_date.required' =>'Interview Date is required',
            'interview_date.before_or_equal:today' =>"Interview Date can't be a future date",
            'volunteer_language.required' => "is required",
            'education.required' => "Education is required",
            'why_interested_volunteering.required' => "Why Interested Volunteering is required",
            'prior_volunteering_experience.required' => "Prior Volunteering Experience is required",
            'experience_explain_geriatic_pop_mental_helth.required' => "Experience Explain Geriatic Pop Mental Health is required",
            'impact_hope_involvement.required' => "Impact Hope Involvement is required",
            'describe_communication_style_close_you.required' => "Describe Communication Style Close You is required",
            'comfortable_languages.required' => "Comfortable Languages is required",
            'senario_speak_client_with_compalaints.required' => "Senario Speak Client With Compalaints is required",
            'have_question.required' => "Have Any Question is required",
            'additional_skills.required' => "Additional Skills is required",
            'vlntr_contract_end_date.required' => "Volunteer Contract End Date is required",
            'update_notes.required' => "Notes are required",
            'training_batch.required' => "Training Batch is required",
            'training_batch.numeric' => "Training Batch is required",

        ];
        $validator = Validator::make($request->all(), $rules, $message);

        if ($validator->fails()) {
            return response()->json(['errors' => $validator->getMessageBag()->toArray()]);
        }
        $v = Application::where('user_id',$request->candidate_id)->first();
        $v->status= "A";
        $v->update();

        $batch = TrainingBatch::find($request->training_batch);
        $batch_book=$batch->is_mandatory;
        // dd($batch);
         
        $form = new InterviewSheet();
         $form->candidate_id=$request->candidate_id;
         $form->interviewer1_id=$request->interviewer1_id;
         $form->interviewer2_id=$request->interviewer2_id;
         $form->interviewer3_id=$request->interviewer3_id;
         $form->Interview_slot_id=$request->Interview_slot_id;
         $form->interview_date=$request->interview_date;
         $form->volunteer_language=$request->volunteer_language;
         $form->education=$request->education;
         $form->why_interested_volunteering=$request->why_interested_volunteering;
         $form->prior_volunteering_experience=$request->prior_volunteering_experience;
         $form->experience_explain_geriatic_pop_mental_helth=$request->experience_explain_geriatic_pop_mental_helth;
         $form->impact_hope_involvement=$request->impact_hope_involvement;
         $form->describe_communication_style_close_you=$request->describe_communication_style_close_you;
         $form->comfortable_languages=$request->comfortable_languages;
         $form->senario_speak_client_with_compalaints=$request->senario_speak_client_with_compalaints;
         $form->have_question=$request->have_question;
         $form->save();

        $volntr= new Volunteer();
        $volntr->vlntr_id=$request->candidate_id;
        $volntr->vlntr_name=$v->full_name;
        $volntr->vlntr_gender=$v->gender;
        $volntr->vlntr_skills=$request->additional_skills;
        $volntr->vlntr_max_clients=$request->no_of_clients;
        $volntr->vlntr_task_Empathy_calls=$request->vlntr_task_empathy_calls;
        $volntr->vlntr_contract_end_date= $request->vlntr_contract_end_date;
        $volntr->vlntr_assign_color=$request->vlntr_assign_color;
        $volntr->vlntr_count_clients=0;
        $volntr->is_active="A";
        $volntr->is_hold="U";
        $volntr->unregistered="R";
        $volntr->updatedby=Auth::user()->id;
        $volntr->save();


        $trainee = new TrainingBatchTraineesUpdate();
        $trainee->tbtu_trainee_id=$request->candidate_id;
        $trainee->tbtu_batch_id=$request->training_batch;
        $trainee->tbtu_notes=$request->update_notes;
        $trainee->tbtu_status="P";
        $trainee->tbtu_booking_type=$batch_book;
        $trainee->updated_by=Auth::user()->id;
        $trainee->save();

    //    email
    $user= User::where('id',$request->candidate_id)->first();
    $to = $user->email;
    $subject = "Application Accepted";
    $text="Check training Batch.";
    
    $cname = $user->first_name;
    $link = route('volunteer.form.one');

    $link = route('volunteer.training.confirm' , $request->batch_id);
    $alink = route('volunteer.training.index' , $request->batch_id );
    Mail::send('email.shortlist', ['altext' => 'Select other Slot' , 'batch' => $batch ,'cname' => $cname, 'text' => $text, 'link' => $link , 'alink' => $alink], function ($message) use ($cname , $to , $subject) {
        $message->to($to , $cname);
        $message->subject($subject);
        $message->from(env('MAIL_FROM_ADDRESS') , 'Tip User');

 });

        return redirect()->back()->with('success' , "Inserted Successfully");
    

       
    }


    public function interviewee_hold(Request $request){
        $rules =
        [
          'Interview_slot_id' =>"required",
          'interview_date' =>'required',
          'interview_date' =>'required|before_or_equal:today',
          'volunteer_language' => 'required',
            'education' => 'required',
            'why_interested_volunteering' => 'required',
            'prior_volunteering_experience' => 'required',
            'experience_explain_geriatic_pop_mental_helth' => 'required',
            'impact_hope_involvement' => 'required',
            'describe_communication_style_close_you' => 'required',
            'comfortable_languages' => 'required',
            'senario_speak_client_with_compalaints' => 'required',
            'have_question' => 'required',
            'additional_skills' => 'required',
            'update_notes' => 'required',
        ];
        $message = [
            'Interview_slot_id.required' =>'Interview Slot is required',
            'interview_date.required' =>'Interview Date is required',
            'interview_date.before_or_equal:today' =>"Interview Date can't be a future date",
            'volunteer_language.required' => "is required",
            'education.required' => "Education is required",
            'why_interested_volunteering.required' => "Why Interested Volunteering is required",
            'prior_volunteering_experience.required' => "Prior Volunteering Experience is required",
            'experience_explain_geriatic_pop_mental_helth.required' => "Experience Explain Geriatic Pop Mental Health is required",
            'impact_hope_involvement.required' => "Impact Hope Involvement is required",
            'describe_communication_style_close_you.required' => "Describe Communication Style Close You is required",
            'comfortable_languages.required' => "Comfortable Languages is required",
            'senario_speak_client_with_compalaints.required' => "Senario Speak Client With Compalaints is required",
            'have_question.required' => "Have Any Question is required",
            'additional_skills.required' => "Additional Skills is required",
            'vlntr_contract_end_date.required' => "Volunteer Contract End Date is required",
            'update_notes.required' => "Notes are required",

        ];
        $validator = Validator::make($request->all(), $rules, $message);

        if ($validator->fails()) {
            return response()->json(['errors' => $validator->getMessageBag()->toArray()]);
        }
        
         $v = Application::where('user_id',$request->candidate_id)->first();
         $v->status= "H";
         $v->update();
         
        $form = new InterviewSheet();
         $form->candidate_id=$request->candidate_id;
         $form->interviewer1_id=$request->interviewer1_id;
         $form->interviewer2_id=$request->interviewer2_id;
         $form->interviewer3_id=$request->interviewer3_id;
         $form->Interview_slot_id=$request->Interview_slot_id;
         $form->interview_date=$request->interview_date;
         $form->volunteer_language=$request->volunteer_language;
         $form->education=$request->education;
         $form->why_interested_volunteering=$request->why_interested_volunteering;
         $form->prior_volunteering_experience=$request->prior_volunteering_experience;
         $form->experience_explain_geriatic_pop_mental_helth=$request->experience_explain_geriatic_pop_mental_helth;
         $form->impact_hope_involvement=$request->impact_hope_involvement;
         $form->describe_communication_style_close_you=$request->describe_communication_style_close_you;
         $form->comfortable_languages=$request->comfortable_languages;
         $form->senario_speak_client_with_compalaints=$request->senario_speak_client_with_compalaints;
         $form->have_question=$request->have_question;
        $form->save();


    
        $volntr= new Volunteer();
        $volntr->vlntr_id=$request->candidate_id;
        $volntr->vlntr_name=$v->full_name;
        $volntr->vlntr_gender=$v->gender;
        $volntr->vlntr_skills=$request->additional_skills;
        $volntr->vlntr_max_clients=$request->no_of_clients;
        $volntr->vlntr_task_Empathy_calls=$request->vlntr_task_empathy_calls;
        $volntr->vlntr_contract_end_date= $request->vlntr_contract_end_date;
        $volntr->vlntr_assign_color=$request->vlntr_assign_color;
        $volntr->vlntr_count_clients=0;
        $volntr->is_active="D";
        $volntr->is_hold="H";
        $volntr->unregistered="R";
        $volntr->updatedby=Auth::user()->id;
        $volntr->save();

        return redirect()->back()->with('success' , "Inserted Successfully");

        
    }
}